/* DSmeister software
 * Sensor interface
 *
 * Created: 2015/09/06
 *  Author: Yaasan
 */ 

#include "MSensor.h"



MSensor::MSensor(int inPin_current, int inPin_voltage)
{
	
	pinCurrent = inPin_current;
	pinVoltage = inPin_voltage;
	
	
	pinMode(pinCurrent, INPUT);
	pinMode(pinVoltage, INPUT);
	
	gSensor_Voltage = 0;		/**< 1V unit(0V to 255V)   */
	gSensor_Current = 0;		/**< 0.1A unit(0.0A to 25.5A)   */
	
	//Initial update
	Update();
}

unsigned char MSensor::GetCurrent()
{
	return gSensor_Current;
}


unsigned char MSensor::GetVoltage()
{
	return gSensor_Voltage;
}



void MSensor::Update(void)
{
	
	//電圧換算
	// 1.2k / 8k  y=((x*8*5)/1.2/1024)
	unsigned short aVolt = analogRead(pinVoltage);
	
	//Limit
	if( aVolt > 922)
	{
		//30Vで打ち止め
		aVolt = 922;
	}
	
	aVolt = aVolt >> 1;//512に分解能を落とす
	
	aVolt = ((aVolt * 125) / 3) >> 6;
	
	if( aVolt > 255)
	{
		//UCに入るサイズにリミット(25.5V)
		aVolt = 255;
	}
	
	gSensor_Voltage = (unsigned char)aVolt;
	
	//電流換算
	
	unsigned short aCurrent = analogRead(pinCurrent);
	
	//絶対値化
	if( aCurrent >= 512)
	{
		aCurrent = aCurrent - 512;
		
	}
	else
	{
		aCurrent = 512 - aCurrent;
	}
	
	//Limit
	if( aCurrent > 409)
	{
		//20Aで打ち止め
		aCurrent = 409;
	}
	
	// y = (x-512)*25/1024
	aCurrent = (aCurrent * 125) >> 8;
	
	if( aCurrent > 255)
	{
		//UCに入るサイズにリミット(25.5A)
		aCurrent = 255;
	}
	
	gSensor_Current = (unsigned char)aCurrent;
	
	
}